.nolist
include \masm32\include\masm32rt.inc
include \masm32\fpulib\fpu.inc
includelib \masm32\fpulib\fpu.lib
.686
include \masm32\macros\timers.asm

dwtoaX	PROTO: DWORD, :DWORD
FS_sprintf	PROTO: DWORD, :DWORD	; crt_sprintf
FloatToStrX	PROTO: QWORD, :PTR CHAR	; copy of MasmLib FloatToStr

; new float to string conversion procedure, for use with float$ macro
FloatStr	PROTO: DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD

; various options for testing
f2sPrec =	7	; max 15 digits (7 is default for FloatToStr, 6 for sprintf)
SwScNotation =	-2	; if exponent < n, switch to scientific notation

UseInit =	1	; 0: don't, 1: do use finit at start of tests
Store8ToFPU =	1	; store 8 values in FPU registers to check for register preservation
SpeedTest =	1	; 0: no timings, set to 0 for fast testing of macros etc

ExRange equ	150	; range ca. e-150...e+150

signed	equ sdword ptr 

; --------------------------------------------------------------
; yields info how to push arg on FPU, and the argument to pass
; 4	Int32, reg32, reg16, reg8, immediate32
; 5	Real4	(called as @MyReal4)
; 8	Real 8	(also immediate real number)
; 10	Real10

ChkNum MACRO argX:REQ
LOCAL ArgType, tmp$, arg, t$, nu8, dot, deco
  aPass$ equ <0>
  arg equ <argX>
  ifb <argX>
	NumSize = 0				;; no argument passed
	EXITM <0>
  endif
  t$ CATSTR <gotcha: >, <argX>
  NumSize = -1					;; global return value
  dot INSTR arg, <.>				;; immediate real?
  deco INSTR arg, <@>			;; immediate real?
  if deco eq 0
	deco INSTR arg, <eal4>		;; dirty hack for TestNum
  endif
  ; deco INSTR <argX>, <@> no
  tmp$ CATSTR <t=>,<arg>, <, dec=>, %deco
  % echo tmp$
  if deco
  	if deco eq 1						;; to distinguish Real4 from Int32,
		arg SUBSTR arg, 2			;; we decorate with a @
		% echo <arg> was decorated
	endif
	NumSize = 5				;; flag REAL4
	ArgType = (opattr(arg)) AND 127
	if ArgType eq atLocal
		aPass$ CATSTR <addr >, <arg>
	else
		aPass$ CATSTR <offset >, <arg>
	endif
	t$ equ <REAL4>
  elseif dot
	.data
		nu8 REAL8 argX			;; write arg to .DATA section
	.code
	NumSize = 8
	aPass$ equ <offset nu8>	;; we pass it as a pointer to the new Real8
	t$ equ <immediate Real8>
  else								;; none of the above
	ArgType = (opattr(arg)) AND 127			;; 0 no vn$, 36 immediate, 42 global, 48 CPU register, 98 local
	if ArgType eq atLocal or ArgType eq atGlobal
		NumSize = SIZEOF arg	;; 4 for DWORD, 10 for REAL10
		if NumSize eq 4
			t$ equ <DWORD>
			aPass$ equ arg		;; Integer pushed directly with fild
		else
			if ArgType eq atLocal
				aPass$ CATSTR <addr >, <arg>
			else
				aPass$ CATSTR <offset >, <arg>
			endif
			if NumSize eq 8
				t$ equ <REAL8>
			elseif NumSize eq 10
				t$ equ <REAL10>
			else
				echo Size %NumSize no good, sorry
				.err
			endif
		endif
	elseif ArgType eq atImmediate
;		tmp$ CATSTR <Immediate passed: >, arg
;		% echo tmp$
		NumSize = 4			;; immediate integer
		aPass$ equ arg			;; push it "as is"
		t$ equ <immediate DWORD>
	elseif ArgType eq atRegister
		NumSize SIZESTR arg
		if NumSize eq 3
			NumSize = 4		;; e?x uses fild, so we flag an integer
			aPass$ equ arg		;; push it "as is"
			t$ equ <DWORD reg>
		else
			tmp$ CATSTR <movzx e>,@SubStr(arg,1,1), <x, >, <arg>
			% echo tmp$
			tmp$
			NumSize=4			;; ?l, ?h, or ?x
			dot INSTR arg, <x>
			if dot eq 0
				t$ equ <BYTE reg>
			else
				t$ equ <WORD reg>
			endif
		endif
	endif
  endif
  MyPass equ aPass$
;  if NumSize eq -1
;	% echo <arg> no good, sorry
;	.err
;  endif
;  tmp$ catstr arg , < is >, %ArgType, <, >, t$, < with size >, %NumSize
;  tmp$ catstr <!>    >, arg , < is >, t$, <, we pass >, aPass$
;  % echo tmp$
  EXITM <NumSize>
ENDM

;     OPATTR guide
;     Bit	Set If...
;     0	References a code label
;     1	Is a memory expression or has a relocatable data label
;     2	Is an immediate expression
;     3	Uses direct memory addressing, i.e. is an absolute memory reference
;     4	Is a register expression
;     5	References no undefined symbols and is without error
;     6	References a stack location (usually a LOCAL variable or parameter)
;     7	References an external label
;     8-10	Language type (0=no type)
		; 76543210
atImmediate	equ 36	; 00100100
atGlobal	equ 42	; 00101010
atRegister	equ 48	; 00110000
atLocal	equ 98	; 01100010

float$ MACRO strformat, arg1, arg2, arg3
LOCAL ArgType, atyB, asiB, tmp$, quotes, arg1a, arg2a, arg3a, mode$, AriMode, FF$, nustr
LOCAL aSize1, aSize2, aSize3
LOCAL aPass1, aPass2, aPass3

; not LOCAL: ArgSize - needed in TestNum
;tmp$ CATSTR <Args passed: >,<strformat>, <, >, <arg1>,<, >, <arg2>,<, >, <arg3>a
;% echo tmp$
  AriMode =	0	;; arithmetic mode
  mode$ equ	<>	;; for debugging with echo
  quotes	INSTR <strformat>, <">
  FF$ equ	<0>	;; FloatFormat$: if 0, use standard
  if quotes eq 0
	quotes	INSTR <strformat>, <'>
  endif
  if quotes eq 1
	arg1a equ <arg1>			;; first arg is a format string
	FF$ equ <offset nustr>		;; we pass it as FF$
	.data
		nustr db strformat, 0		;; write arg to .DATA section
	.code
  else
	arg1a	equ <strformat>		;; first arg is the number
  endif
  arg2a	equ <0>
  arg3a	equ <0>
  IsDiv	INSTR	arg1a, </>
  IsMul	INSTR	arg1a, <*>
  IsPlus	INSTR	arg1a, <+>
  IsMinus	INSTR	arg1a, <->
  if IsMul
	arg2a SUBSTR arg1a, IsMul+1
	arg1a SUBSTR arg1a, 1, IsMul-1
	% echo Calc arg1a*arg2a
	mode$ CATSTR mode$, < mult>
	AriMode = 4
	IsMul INSTR arg2a, <*>
	if IsMul		;; same operator twice?
		arg3a SUBSTR arg2a, IsMul+1
		arg2a SUBSTR arg2a, 1, IsMul-1
		AriMode = AriMode + 4*256
	endif
  endif
  if IsDiv
	if AriMode
		IsDiv INSTR arg2a, </>
		arg3a SUBSTR arg2a, IsDiv+1
		arg2a SUBSTR arg2a, 1, IsDiv-1
		AriMode = AriMode + 8*256
	else
		arg2a SUBSTR arg1a, IsDiv+1
		arg1a SUBSTR arg1a, 1, IsDiv-1
		AriMode = 8
	endif
	IsDiv INSTR arg2a, </>
	if IsDiv
		arg3a SUBSTR arg2a, IsDiv+1
		arg2a SUBSTR arg2a, 1, IsDiv-1
		AriMode = AriMode + 8*256
	endif
;	% echo Calc arg1a/arg2a
	mode$ CATSTR mode$, < div>
  endif
  if IsPlus
	if AriMode
		IsPlus INSTR arg2a, <+>
		arg3a SUBSTR arg2a, IsPlus+1
		arg2a SUBSTR arg2a, 1, IsPlus-1
		AriMode = AriMode + 1*256
	else
		arg2a SUBSTR arg1a, IsPlus+1
		arg1a SUBSTR arg1a, 1, IsPlus-1
		AriMode = 1
	endif
	IsPlus INSTR arg2a, <+>
	if IsPlus		;; same operator twice?
		arg3a SUBSTR arg2a, IsPlus+1
		arg2a SUBSTR arg2a, 1, IsPlus-1
		AriMode = AriMode + 1*256
	endif
;	% echo Calc arg1a+arg2a
	mode$ CATSTR mode$, < plus>
  endif
  if IsMinus gt 2
	if AriMode
		IsMinus INSTR arg2a, <->
		arg3a SUBSTR arg2a, IsMinus+1
		arg2a SUBSTR arg2a, 1, IsMinus-1
		AriMode = AriMode + 2*256
	else
		arg2a SUBSTR arg1a, IsMinus+1
		arg1a SUBSTR arg1a, 1, IsMinus-1
		AriMode = 2
	endif
	IsMinus INSTR arg2a, <->
	if IsMinus		;; same operator twice?
		arg3a SUBSTR arg2a, IsMinus+1
		arg2a SUBSTR arg2a, 1, IsMinus-1
		AriMode = AriMode + 2*256
	endif
;	% echo Calc arg1a-arg2a
	mode$ CATSTR mode$, < minus>
	; AriMode = AriMode + 2 ????
  endif
  echo
  echo
  tmp$ CATSTR <--- Start >, <arg1a>, <, >, <arg2a>, <, >, <arg3a>, < ----->
  % echo tmp$
  echo
;  tmp$ CATSTR <Arimo=>, %AriMode
;  % echo tmp$
  aSize1 = ChkNum(arg1a)
  % aPass1 equ aPass$
  tmp$ CATSTR <Pass1:  >, <aPass1>, <, size >, %aSize1, <, arg=>, <arg1a>
  % echo tmp$
  aSize2 = 0			;; default
  aSize3 = 0			;; default
  if AriMode
	aSize2 = ChkNum(arg2a)
	% aPass2 equ <aPass$>
	tmp$ CATSTR <Pass2:  >, aPass2, <, size >, %NumSize
	% echo tmp$
	if AriMode ge 256
		aSize3 = ChkNum(arg3a)
		% aPass3 equ <aPass$>
		tmp$ CATSTR <Pass3:  >, <aPass3>, <, size >, %NumSize
		% echo tmp$
	else
		aPass3 equ <0>
	endif
  else
	aPass2 equ <0>
	aPass3 equ <0>
  endif
  ArgSize = aSize1 + aSize2 * 256 + aSize3 * 65536			;; global for TestNum

  tmp$ CATSTR <invoke FloatStr, >, <FF$>, <, >, <aPass1>, <, >, <aPass2>, <, >, <aPass3>, <, >, %AriMode, <, >, % ArgSize

  echo
  % echo tmp$
  % invoke FloatStr, FF$, aPass1, aPass2, aPass3, AriMode, ArgSize
  echo
 ;  .err
  EXITM <offset f2sBuffer>
ENDM

TestNum MACRO tproc:REQ, testnum:REQ
LOCAL tmp$
	tmp$ CATSTR <">,<testnum>,<">
;	print chr$(tmp$, 9)
  if Store8ToFPU
	call LoadFPU
  endif
  if tproc eq 0
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		invoke FloatToStrX, testnum, addr f2sBuffer
		; int 3	; discards ST 6, 7, 8
	counter_end
	print ustr$(eax)," cycles for FloatToStr", 9
	print offset f2sBuffer, 13, 10

  elseif tproc eq 1
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		mov eax, float$(testnum)
		; int 3	; to test whether ST registers are intact (they are ;-)
	counter_end
	if ArgSize eq 4	;; 4 for DWORD, 10 for REAL10, 99 for immediate and reg
		tmp$ CATSTR <" cycles for float$ >, <testnum>,<">
	else
		tmp$ CATSTR <" cycles for float$ Real>, %ArgSize, <">
	endif
	% print ustr$(eax), tmp$, 9
	print offset f2sBuffer, 13, 10

  elseif tproc eq 2
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		mov edx, offset testnum
		call F2sRay
		; int 3	; to test whether ST registers are intact
	counter_end
	print ustr$(eax)," cycles for Ray's lib", 9
	mov edx, offset f2sBuffer
	mov al, [edx]
	.if al==32
		inc edx
	.endif
	print edx, 13, 10

  else
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		INVOKE crt_sprintf, ADDR f2sBuffer, ADDR f2sFormat, testnum
		; int 3	; to test whether ST registers are intact
	counter_end
	print ustr$(eax)," cycles for sprintf  ", 9
	print offset f2sBuffer, 13, 10

  endif
ENDM

.data?
f2sP10	REAL8 ExRange*2 dup(?)
f2sDummy	dw ?
f2sBuffer	dd 80 dup(?)	; returned by float$
f2sTmpBuf	dd 10 dup(?)	; internal buffer for f2sForm$

.data
f2sSeed	@CatStr(<REAL10 1.0e+>,%ExRange+6)
f2s0dot1	REAL10	0.1
f2sRnd5	REAL8	5.0		; 5.0 is just fine
f2sRndLog	REAL8	1.1e-17		; solves a problem with 9.99..99enn

MyReal4a	Real4	+1.23456789012345678e-5	; +6 still normal notation in sprintf
MyReal4b	Real4	+1.23456789012345678e-1	; -4 still normal notation in sprintf
MyReal4c	Real4	+1.23456789012345678+0	; rule: >-4 or <precision
MyReal4d	Real4	+1.23456789012345678e+3	; rule: >-4 or <precision
MyReal4e	Real4	+1.23456789012345678e+23
MyReal4f	Real4	 -1.23456789012345678e-23
MyReal4g	Real4	0.0

MyReal8a	REAL8	+1.23456789012345678e-4	; +6 still normal notation in sprintf
MyReal8b	REAL8	+1.23456789012345678e-1	; -4 still normal notation in sprintf
MyReal8c	REAL8	+1.23456789012345678+0	; rule: >-4 or <precision
MyReal8d	REAL8	+1.23456789012345678e+3	; rule: >-4 or <precision
MyReal8e	Real8	+1.23456789012345678e+123
MyReal8f	Real8	 -1.23456789012345678e-123
MyReal8g	Real8	0.0

MyReal10a	Real10	+1.23456789012345678e-3	; +6 still normal notation in sprintf
MyReal10b	Real10	+1.23456789012345678e-1	; -4 still normal notation in sprintf
MyReal10c	Real10	+1.23456789012345678+0	; rule: >-4 or <precision
MyReal10d	Real10	+1.23456789012345678e+3	; rule: >-4 or <precision
MyReal10e	Real10	+1.23456789012345678e+123
MyReal10f	Real10	 -1.23456789012345678e-123
MyReal10g	Real10	0.0

MyReal4	REAL4	1.234
MyReal	REAL4	1.234
MyInt4	dd	12345678

mta	REAL4	1234.5	; just for fun, we mix a real 4 with a real 10 for
mtb	REAL10	123.45	; calculating mta/mtb+113

; R10 for testing of formats - set SpeedTest = 0

R10a	REAL10	+1.234567890123456789e+20	; +6 still normal notation in sprintf	; MyInt3
R10b	REAL10	+1.234567890123456789e-20	; -4 still normal notation in sprintf
R10c	REAL10	+1.0e+20	; rule: >-4 or <no. precision digits
R10d	REAL10	+1.0e-20
R10e	REAL10	-1.0e+20
R10f	REAL10	-1.0e-20
R10g	REAL10	+8.99999999999999999e123
R10h	REAL10	+9.00000000000000001e123
R10i	REAL10	+9.99999999999999999e99	; 99->100	until 116 ok,
R10j	REAL10	 -9.99999999999999999e-101	; -101->100	but 118 fails...

;R10a	REAL10	+1.234567890123456789e+6	; +6 still normal notation in sprintf
;R10b	REAL10	-2.234567890123456789e-4	; -4 still normal notation in sprintf
;R10c	REAL10	+3.234567890123456789e-2	; rule: >-4 or <no. precision digits
;R10d	REAL10	-4.234567890123456789e0
;R10e	REAL10	+5.234567890123456789e4
;R10f	REAL10	-6.234567890123456789e8
;R10g	REAL10	+7.234567890123456789e12
;R10h	REAL10	-8.234567890123456789e14
;R10i	REAL10	+9.234567890123456789e123
;R10j	REAL10	-9.234567890123456789e-123

R10_Null	REAL10	0.0

; for debugging:
MyInt3	dd	0
; .if MyInt3
;	int 3
; .endif

;5575 cycles with xStr, Real10   -0.00022
;5235 cycles with xStr, Real10   0.032345
;5364 cycles with xStr, Real10   -4.23456
;5626 cycles with xStr, Real10   52345.67
;5414 cycles with xStr, Real10   -6.23456e+08
;5211 cycles with xStr, Real10   7.234567e+12
;4624 cycles with xStr, Real10   -8.23456e+14
;6646 cycles with xStr, Real10   9.234567e+123
;6350 cycles with xStr, Real10   -1.23456e-123

f2sFormat	db "%.7g", 0

ten	dq	10.0

ten_1	dt	1.0e1
	dt	1.0e2
	dt	1.0e3
	dt	1.0e4
	dt	1.0e5
	dt	1.0e6
	dt	1.0e7
	dt	1.0e8
	dt	1.0e9
	dt	1.0e10
	dt	1.0e11
	dt	1.0e12
	dt	1.0e13
	dt	1.0e14
	dt	1.0e15

ten_16	dt	1.0e16
	dt	1.0e32
	dt	1.0e48
	dt	1.0e64
	dt	1.0e80
	dt	1.0e96
	dt	1.0e112
	dt	1.0e128
	dt	1.0e144
	dt	1.0e160
	dt	1.0e176
	dt	1.0e192
	dt	1.0e208
	dt	1.0e224
	dt	1.0e240

ten_256	dt	1.0e256
; The remaining exponents are only necessary if we decide to support
; 10-byte doubles.  FloatToStr and StrToFloat only support 8-byte,
; but PowerOf10 doesn't care, so we'll include them.
	dt	1.0e512
	dt	1.0e768
	dt	1.0e1024
	dt	1.0e1280
	dt	1.0e1536
	dt	1.0e1792
	dt	1.0e2048
	dt	1.0e2304
	dt	1.0e2560
	dt	1.0e2816
	dt	1.0e3072
	dt	1.0e3328
	dt	1.0e3584
	dt	1.0e4096
	dt	1.0e4352
	dt	1.0e4608
	dt	1.0e4864
tenX	dd	0

MyReal10	REAL10	1.2345678e9

.code

start:	if UseInit
		finit		; a pretty slow instruction, so testing its performance might be useful
	endif
	; int 3
	; f2sPrec = 8	; for debugging - precision should be under the PROTOs
	mov eax, 12345678
	print float$("\n------- New float$ macro: ---------------------\nDivide\tMyReal10\t(=1.2345678e9)\nby\t12345678\t(=1.2e7, in eax)\nadd\t 11.1111   \t(an immediate real)\nResult=\t%f\n-- This para printed by one line of code! -----\n\n", MyReal10/eax+011.1111)
	; MsgBox 0, float$("------- New float$ macro: -------------------\nDivide\tMyReal10 (=1.2345678e9)\nby\t12345678\nadd\t11\nResult=\t%f\n-- This para created by ONE line of code! --", MyReal10/12345678+11), "Test float$ macro:", MB_OK

	call ShowInfo	; display size and FPU register preservation

	; inc MyInt3		; debug?
	; print float$("\nThe number %f is far too big", MyReal10)
	; print float$("\nThe number %f is far too small", MyReal10/12345678+11)

	if SpeedTest	; full test
		LoopFast	= 0	; put 1 for speeding up things
		LoopCount	= 1000000-900000*LoopFast
		if UseInit
			print chr$(13, 10, "finit is ON")
		else
			print chr$(13, 10, "finit is OFF")
		endif
		print chr$(9, "Version 1.1, 1 September 2008",13,10)

		invoke Sleep, 1000-900*LoopFast

		TestNum 0, MyReal8a	; 0 = FloatToStr ( Masm32 lib )
		TestNum 1, MyReal4a	; 1 = FloatStr ( jj2007 )
		mov MyInt3, 1
		TestNum 1, MyReal8a
		TestNum 1, MyReal10a
	if 0
		push edi
		mov edi, 2147483647	; 2^31-1
		TestNum 1, edi
		pop edi
	endif
		TestNum 2, MyReal10a	; 2 = Raymond Filiatreault's FpuLib
		TestNum 3, MyReal8a	; 3 = crt_sprintf ( C++ )

		print chr$(13, 10, "---------", 10)
		TestNum 0, MyReal8b
		TestNum 1, MyReal4b
		TestNum 1, MyReal8b
		TestNum 1, MyReal10b
		TestNum 2, MyReal10b
		TestNum 3, MyReal8b

		print chr$(13, 10, "---------", 10)
		TestNum 0, MyReal8c
		TestNum 1, MyReal4c
		TestNum 1, MyReal8c
		TestNum 1, MyReal10c
		TestNum 2, MyReal10c
		TestNum 3, MyReal8c

		print chr$(13, 10, "---------", 10)
		TestNum 0, MyReal8d
		TestNum 1, MyReal4d
		TestNum 1, MyReal8d
		TestNum 1, MyReal10d
		TestNum 2, MyReal10d
		TestNum 3, MyReal8d

		print chr$(13, 10, "---------", 10)
		TestNum 0, MyReal8e
		TestNum 1, MyReal4e
		TestNum 1, MyReal8e
		TestNum 1, MyReal10e
		TestNum 2, MyReal10e
		TestNum 3, MyReal8e
	if 1
		print chr$(13, 10, "---------", 10)
		TestNum 0, MyReal8f
		TestNum 1, MyReal4f
		TestNum 1, MyReal8f
		TestNum 1, MyReal10f
		TestNum 2, MyReal10f
		TestNum 3, MyReal8f

		print chr$(13, 10, "---------", 10)
		TestNum 0, MyReal8g
		TestNum 1, MyReal4g
		TestNum 1, MyReal8g
		TestNum 1, MyReal10g
		TestNum 2, MyReal10g
		TestNum 3, MyReal8g
	endif
	elseif 1
		LoopCount = 1 ; 00000		; for testing

		; call LoadFPU		; instead of Store8ToFPU
		push edi
		mov edi, 1234512345	; or 2147483647	= 2^31-1
		TestNum 1, edi			; works perfectly

		; TestNum 1, MyInt4		; will not work, mistaken as Real4

		TestNum 1, 12345678	; try an immediate? It works...
		pop edi
	if 0
		TestNum 1, R10_Null
		TestNum 1, R10a
		TestNum 1, R10b
		TestNum 1, R10c
		TestNum 1, R10d
		TestNum 1, R10e
		TestNum 1, R10f
		TestNum 1, R10g	; xxx
		TestNum 1, R10h
		TestNum 1, R10i
		TestNum 1, R10j
	endif
		print chr$(13, 10, "---------", 10)
		print float$("\na=1234.5, b=123.45, c=113.4567:\na/b+c=%f", @mta/mtb+113.4567)
		print float$("\na=1234.5, b=123.45, c=113 (1.722e8):\na*b*c=%f", @mta*mtb*113)
		print float$("\na=1234.5, b=123.45, c=113:\na/b/c=%f", @mta/mtb/113)
		print float$("\na=1234.5, b=123.45, c=113:\na+b+c=%f", @mta+mtb+113)
		mov MyInt3, 1	; Pass1
		print float$("\na=1234.5, b=123.45, c=113:\na-b-c=%f", @mta+MyInt3)
		print chr$(13, 10, 10, "---------", 10)

	endif
	exit

	; crash
	; MsgBox 0, edx, "ST$ test:", MB_OK

FloatStr proc	f2sForm$:DWORD,			; pointer to e.g. "The relation A:B is %f"
	arg1a:DWORD,			; pointer to the first number
	arg1b:DWORD, arg1c:DWORD,	; optional 2nd and 3rd numbers
	f2sMode:DWORD, f2sSize:DWORD	; mode: mul, div, add, sub and size (Int=4, Real4=5, R8, R10)

;  ArgSize = aSize1 + aSize2 * 256 + aSize3 * 65536			;; global for TestNum
;  invoke FloatStr, FF$, aPass1, aPass2, aPass3, AriMode, ArgSize

LOCAL f2sSign:DWORD
LOCAL f2sST0:REAL10
LOCAL f2sST1:REAL10
LOCAL f2sTmp8:REAL8
LOCAL f2sDot:DWORD
LOCAL f2sExpo:DWORD
LOCAL f2sBufPos:DWORD
LOCAL f2sConWold:WORD
LOCAL f2sConW:WORD

COMMENT @ ------------------------------------------------------------------------------------------------------
This routine should be called through the float$ macro, so
that the appropriate size can be chosen. For use without this macro:

	ArgSize = SIZEOF testnum	; 4 for DWORD, 8 for REAL8, 10 for REAL10
	arg1a	= offset testnum or ecx or 12345 or whatever address your number is
	arg1b	= 123 (any immediate will do)
	argC	= how you intend to calculate with arg1b: IsPlus+2*IsMinus+4*IsMul+8*IsDiv
	invoke FloatStr, arg1a, ArgSize, argC, arg1b

--------	jj2007 August 2008 - use at your own risk --------------------------------------------- @
	push ebx	; save regs
	push edi
	push esi
	mov esi, offset f2sBuffer
	mov edi, f2sForm$		; do we have a string  la "The number %f is too small"?
	.if edi
			xor eax, eax
	@@:	mov al, [edi]
			test eax, eax
			je @F
			cmp al, "%"
			je @F					; insert number: we are done here

			mov cx, [edi]
			cmp cx, "t\"				; tab?
			jne NoTab
			sub eax, 92-9			; mov al, 9
			inc edi
			jmp NoLf

	NoTab:	cmp cx, "n\"				; newline?
			jne NoLf
			sub eax, 92-13			; mov al, 13
			mov [esi], al
			inc esi
			inc edi
			sub eax, 3				; mov al, 10

	NoLf:	mov [esi], al
			inc edi
			inc esi
			jmp @B

	@@:	mov f2sForm$, edi		; we'll do the rest after we are finished ...

	.endif
	mov f2sBufPos, esi				; ... with the number, starting from current esi
	mov edi, arg1a					; addr to first number, or number itself

	fstcw f2sConWold				; status word could be saved as fstsw ax,
	mov ax, f2sConWold			; but no such instruction for Control word
	or ax,	010000000000b			; set rounding mode to DOWN
	or eax,	001100000000b			; 64 bits precision
	mov f2sConW, ax
	fldcw word ptr f2sConW

	mov edx, offset f2sP10
	fstp f2sST0						; free two registers
	mov eax, [edx]
	fstp f2sST1
	.if eax==0
		fld f2s0dot1
		fld f2sSeed
		mov ecx, ExRange*2
@@:		fmul st, st(1)
		fst REAL8 ptr [edx]
		add edx, 8
		dec ecx
		jne @B
		fstp st					; pop 2 registers, 
		fstp st					; old ST0 will be on top again
	.endif
	fldlg2						; load constant, 8 cycles
	mov ecx, f2sSize
	;  ArgSize = aSize1 + aSize2 * 256 + aSize3 * 65536			;; global for TestNum
	; and ecx, 0ffffh				; mask out size for second arg
	.if cl==10
		fld REAL10 ptr [edi]		; load from mem, 6 cycles
	.elseif cl==8
		fld REAL8 ptr [edi]		; load from mem, 3 cycles
	.elseif cl==5
		fld REAL4 ptr [edi]		; load from mem, 3 cycles
	.elseif cl==4
		push edi
		fild dword ptr [esp]		; push an integer (reg or immediate)
		pop eax
	.endif
	mov eax, f2sMode
	.if eax
		mov edx, arg1b			; addr to Number
		.if ch==10
			fld REAL10 ptr [edx]		; load from mem, 6 cycles
		.elseif ch==8				; test mtb is REAL8
			fld REAL8 ptr [edx]		; load from mem, 3 cycles
		.elseif ch==5
			fld REAL4 ptr [edx]		; load from mem, 3 cycles
		.elseif ch==4
			push edx
			fild dword ptr [esp]		; push an integer (reg or immediate)
			pop ecx
		.endif
		.if al==1	; add
			fadd
		.elseif al==2
			fsub
		.elseif al==4
			fmul
		.else
			fdiv
		.endif
		.if ah
			mov edx, arg1c				; addr to Number
			mov cl, byte ptr f2sSize+2
			.if cl==10
				fld REAL10 ptr [edx]		; load from mem, 6 cycles
			.elseif cl==8
				fld REAL8 ptr [edx]		; load from mem, 3 cycles
			.elseif cl==5
				fld REAL4 ptr [edx]		; load from mem, 3 cycles
			.elseif cl==4
				push edx
				fild dword ptr [esp]		; push an integer (reg or immediate)
				pop edx
			.endif
			.if ah==1	; add
				fadd
			.elseif ah==2
				fsub
			.elseif ah==4
				fmul
			.else
				fdiv
			.endif
		.endif
		; MsgBox 0, str$(ecx), "Ecx=", MB_OK
	.endif
	; fst f2sTmp8
	xor ecx, ecx					; sign flag
	ftst							; test for zero
	fstsw ax
	sahf
	je f2sZero					; 0.0
	jnc f2sPos					; above zero

f2sNeg:
	inc ecx
	fabs						; neg?

f2sPos:
	fst f2sTmp8
	mov f2sSign, ecx
;	.if MyInt3==0
	fyl2x						; log, 196-329 cycles
;	.endif
	fld f2sRndLog
	.if MyInt3
		; int 3
	.endif
	fadd st(1), st
	fstp st						; pop ST
	; frndint						; truncate, i.e. round down
	push eax					; create a stack slot
	fistp dword ptr [esp]			; get log10(num)
	mov ecx, [esp]				; truncate and put into ecx
	pop edx						; restore CPU stack
	fld f2sTmp8					; load from mem, 3 cycles

	lea edx, [f2sP10+8*ecx+8*ExRange-8*f2sPrec+5*8+0]	; xxx max precision is 17
	fld REAL8 ptr [edx]			; multiply the original number by 1.0 Exx
	fmul						; normalise to a positive number (16 cycles)
	fld f2sRnd5
	fadd st(1),st					; round the integer upwards by adding 0.5
	fstp st						; pop ST
;	.if MyInt3==0
		fbstp real10 ptr f2sTmpBuf	; ca. 200 cycles on Core Duo; Memory operands can be ... or 64-bit integers for FISTP.
;	.else
;		fstp st					; pop ST
;	.endif
	mov edi, offset f2sTmpBuf+(f2sPrec+1)/2			; xxx the BCD buffer
	inc ecx						; expo
	mov f2sExpo, ecx			; save for later use
	mov edx, ecx				; for comparison
	.if ecx>=f2sPrec
		mov edx, 1
	.endif
	m2m ebx, f2sPrec+1		; xxx no. of digits inserted -> delimiter v
	.if f2sSign
		mov al, "-"
		mov [esi], al
		inc esi
		inc f2sBufPos			; xxx
	.endif
	.if signed ecx<=0
		.if signed ecx>=SwScNotation
			mov al, "."
			mov [esi+1], al			; Ascii 46 at pos 1
			add al, 2
			mov [esi], al			; Ascii 48 at pos 0, leading 0
			inc esi
			mov edx, ecx
	@@:	inc esi
			mov [esi], al
			inc f2sBufPos			; xxx delimiter
			inc f2sExpo
			inc edx
			jle @B
			or edx, -1				; no more dots
			dec ebx
		.endif
	.endif
	xor ecx, ecx				; counter to zero
	mov f2sDot, ecx			; flag
;	mov [esi+ebx], ecx		; delete remainders from previous calls

		; transfer the BCD number to a buffer
		mov al, [edi]			; first byte in BCD buffer
		dec edi
		test al, al				; if two leading zeros,
		jne f2sL0b				; then get [edi-1] right below

f2sL0:	mov al, [edi]			; get 4 bytes=8 numbers
		dec edi

f2sL0b:	mov ah, al				; save high nibble
		sar al, 4				; calc low nibble
		and ax, 0F0Fh			; mask both nibbles in ah and al
		add ax, 3030h			; convert to ascii
		test ecx, ecx			; in the first loop, we check
		jne NoSkip				; if there is a leading "0"
		test al,  0Fh 			; al has 30h plus original nibble
		je	Skip0
NoSkip:	mov [esi+ecx], al		; low nibble
		inc ecx
		cmp ecx, ebx			; compare to full precision
		jae @F
Skip0:	cmp ecx, edx			; 1st test: Dot needed here?
		je f2sPutDotA

f2sPutDot1:
		mov [esi+ecx], ah		; high nibble
		inc ecx
		cmp ecx, edx			; 2nd test: Dot needed here?
		je f2sPutDotB

f2sPutDot2:
		cmp ecx, ebx			; compare to full precision
		jb f2sL0					; one more loop ^

@@:		mov esi, f2sBufPos
		mov ecx, f2sExpo
		mov al, 0						; flag v
;			.if MyInt3
;				int 3
;			.endif
		mov [esi+f2sPrec+1], al			; xxx zero delimiter -> inserted ^
		dec ecx
		.if signed ecx<SwScNotation		; jge ...
			neg ecx
			mov eax, "0-e"
		.elseif signed ecx>=f2sPrec-1	; ... here: HL looks complicated
			mov eax, "0+e"				; but its coding is quite efficient
		.endif
		.if al	; flag ^
			lea edi, [esi+f2sPrec+1]
			mov [edi], eax				; +-e0
			mov eax, ecx
			mov ebx, 10
			xor edx, edx				; for div, edx must be zero
			div ebx						; result in eax, remainder in edx
			.if ecx<100
				dec edi					; we need less space for the expo
				mov [edi+5], dh			; terminating null byte
			.endif
			add dl, 30h					; last number of exponent
			add edi, 3
			mov [edi+1], dl				; 96/10=9 in eax, 6 in edx
			.if ecx>=100					; 104/10=10 in eax, 4 in edx, then 1 in eax, 0 in edx
				xor edx, edx			; for div, edx must be zero
				div ebx					; divide eax by 10 again
				add dl, 30h
				mov [edi+2], dh			; terminating null byte
				mov [edi], dl			; 2 in edx, 1 in eax
				dec edi
			.endif
			add al, 30h
			mov [edi], al
			mov esi, edi
		.endif
		jmp f2sDone

f2sPutDotA:
		inc f2sDot
f2sPutDotB:
		push eax	; ebx
		mov al, "."
		mov [esi+ecx], al			; insert the dot here
		pop eax
		inc ecx
		.if f2sDot
			jmp f2sPutDot1
		.endif
		jmp f2sPutDot2

; ------------	finish the job  ------------------------
f2sZero:	mov ax, "0"					; shorter than
		mov f2sBuffer, eax			; mov buf, "0"
		fstp st						; pop 2 registers, old
		fstp st						; ST0 will be on top again

f2sDone:
	mov edi, f2sForm$				; do we have a leftover from the format string?
	.if edi
	@@:	lodsb					; only 3 or 4 loops
			test al, al				; inc esi until nullbyte found
			jne @B
			add edi, 2				; get rid of %f
			dec esi

	@@:	mov al, [edi]
			test al, al
			je @F

			mov cx, [edi]
			cmp cx, "n\"				; newline?
			jne NoLf2
			sub eax, 92-13			; mov al, 13
			mov [esi], al
			inc esi
			inc edi
			sub eax, 3				; mov al, 10

	NoLf2:	mov [esi], al
			inc esi
			inc edi
			jmp @B
	@@:
			mov [esi], al
	.endif
	pop esi		; restore regs
	pop edi
	pop ebx
	fld f2sST1						; restore 2 registers
	fld f2sST0
	fldcw word ptr f2sConWold		; restore control word
  ret
FloatStr endp
f2sGL1:

LoadFPU proc						; test: load all 8 FPU regs
		if UseInit
			finit
		endif
		xor eax, eax
		mov ecx, offset f2sP10	; clear the first table entry to
		mov [ecx], eax			; signal it has to be created again
		mov ecx, 8
@@:		push ecx
		fild dword ptr [esp]
		pop ecx
		dec ecx
		jne @B
;		pushad
;		print chr$(13, 10, "Init", 13,10)
;		popad
		ret
LoadFPU endp

ReLoad proc
	mov edx, offset f2sP10
	xor eax, eax
	mov [edx], eax		; force reload
	ret
ReLoad endp

ShowInfo proc
	print chr$(13, 10, "Code sizes and FPU register preservation:")
	print chr$(13, 10, "FloatToStr", 9,"size=")
	mov eax, offset f2sGL0
	sub eax, offset FloatToStrX
	add eax, offset tenX
	sub eax, offset ten
	print ustr$(eax)
	print chr$(", ST 6-8 trashed")

	print chr$(13, 10, "float$   ",9,"size=")
	mov eax, offset f2sGL1
	sub eax, offset FloatStr
	print ustr$(eax)
	print chr$(", all ST regs preserved")

	print chr$(13, 10, "Ray's lib",9,"size=700")
	print chr$(", all ST regs preserved")

	print chr$(13, 10, "crt sprintf",9,"size=???")
	print chr$(", all ST regs preserved", 13, 10)
	ret
ShowInfo endp

F2sRay proc
  if 0
	ffree st(7)
	fld REAL8 ptr [edx]		; load from mem, 3 cycles - any chance to determine size at runtime?
  endif
  invoke FpuFLtoA, edx, 6, offset f2sBuffer, SRC1_REAL or SRC2_DIMM ; or STR_SCI
  ret
F2sRay endp

if 0
MacTest proc
Local MyLocal4:REAL4, MyLocal8:REAL8, MyLocal10:REAL10

	if 1

	else

	print chr$(13, 10, "We divide MyReal4a by 1234: ")
				mov ecx, 12345678
	print float$(MyReal4a*10000000/ecx)
	print chr$(13, 10, "We multiply MyReal4a by 1000: ")
	print float$(MyReal4a*1000)
	print chr$(13, 10, "We calculate 12*1000+345: ")
	print float$(12*1000+345)
	print chr$(13, 10, "We calculate 0*1000+345: ")
	print float$("\nThe number %f is far too big", 12*1000+345)
	if 0
	print float$(MyReal8)			; print fld, fst, crt_sprintf
	print float$(MyReal10a)			; print fld, fst, crt_sprintf
	print float$(MyReal10a*123)		; print fld, fst, crt_sprintf
	print float$(MyInt4)			; fild, fst, crt_sprintf
	print float$(MyLocal8)			; crt_sprintf
	print float$(MyLocal4)			; print fld, fst, crt_sprintf
	print float$(MyLocal10)		; print fld, fst, crt_sprintf
	print float$(MyLocal10*123)		; print fld, fst, crt_sprintf
	print float$("123.456")			; just copy
	print float$(-1)			; pop ST(0)
	print float$(0, addr bf)			; fst ST(0), write to bf
	print float$(1)			; fst ST(1)
	print float$(eax, edx)			; fild eax, write to edx
	print float$(AX, edx)			; fild eax, write to edx
	print float$(al, edx)			; fild eax, write to edx
	print float$(eax/edx)			; fild eax, fild edx, div
	print float$(eax/1024, edx)		; fild eax, push and divide 1024, write to edx
	; print float$(1, "A float: %.7e", addr bf)	; don't use f2sFormat
	; print float$("%.5g")			; plain ST(0), don't use f2sFormat
	; print float$("ST(0) contains %.5g")	; don't use f2sFormat
	; print float$(-1, "ST(0) contained %.5g")	; don't use f2sFormat
	; print float$(1, "ST(1) contains %.5g")	; don't use f2sFormat
	print float$(ST(3))			; 
	print float$(ST)			; 
	print float$(st(2))			; 
	; print float$(mm0)			; 
	; print float$(mm3)			; 
	endif
	if 1
		.data
	f2sLog10	REAL10	0.30303030303030303030
		.code
		finit
		push esi
		mov esi, offset f2sBuffer
		; int 3

		mov edx, offset MyReal8a
		fldlg2
		fld REAL8 ptr [edx]		; load from mem, 3 cycles
		fyl2x
		FBSTP [esi]
		MsgBox 0, esi, "Test", MB_OK
		pop esi
		exit

		fld REAL8 ptr [edx]		; load from mem, 3 cycles
		fxtract	; log
		fstp st					; pop st
		fldlg2
		; fld f2sLog10
		fmul
		fdiv

		mov edx, offset MyReal8b
		fldlg2
		fld REAL8 ptr [edx]		; load from mem, 3 cycles
		fyl2x
		; fstp st					; pop 2 registers, 
		fld REAL8 ptr [edx]		; load from mem, 3 cycles
		fxtract	; log
		fstp st					; pop st
		fldlg2
		; fld f2sLog10
		fmul
		fdiv

		mov edx, offset MyReal8c
		fldlg2
		fld REAL8 ptr [edx]		; load from mem, 3 cycles
		fyl2x
		; fstp st					; pop 2 registers, 
		fld REAL8 ptr [edx]		; load from mem, 3 cycles
		fxtract	; log
		fstp st					; pop st
		fldlg2
		; fld f2sLog10
		fmul
		fdiv

		mov edx, offset MyReal8d
		fldlg2
		fld REAL8 ptr [edx]		; load from mem, 3 cycles
		fyl2x
		; fstp st					; pop 2 registers, 
		fld REAL8 ptr [edx]		; load from mem, 3 cycles
		fxtract	; log
		fstp st					; pop st
		fldlg2
		; fld f2sLog10
		fmul
		fdiv
	endif
endif

  ret
MacTest endp

FS_sprintf proc uses esi f2sNum:DWORD, f2sBuf:DWORD
	INVOKE crt_sprintf, ADDR f2sBuffer, ADDR f2sFormat, REAL8 PTR [eax]
	mov edx, offset f2sBuffer
  ret
FS_sprintf endp
endif
if 0
CopyMem	PROTO: DWORD, :DWORD, :DWORD	; GeneSys

align 4
CopyMem proc uses esi edi lpSource:DWORD,lpDest:DWORD,bcount:DWORD
;--------------------------------------- adapted from GeneSys, this version 32 bytes
;    push    esi
;    push    edi
;    cld                                 ; Clear direction flag
    mov     esi, lpSource               ; Source address in ESI
    mov     edi, lpDest                 ; Destination address in EDI
    mov     ecx, bcount                 ; Byte count to copy in ECX
	push	ecx
    shr     ecx, 2                      ; Divide count by 4
    rep     movsd                       ; Copy DWORD size blocks
	pop		ecx
;	 mov     ecx, bcount                 ; Reload byte count
    and     ecx, 3                      ; Calculate remainder
    rep     movsb                       ; Copy tail
;    pop     edi
;    pop     esi
    ret
;---------------------------------------
CopyMem endp

Dummy proc
  push esi
  pop esi
  ret
Dummy endp
endif
; Tim N. Roberts.


; These are bits in the FP status word.

FP_LESSTHAN	equ	01h
FP_EQUALTO	equ	40h

	.data

; I'd rather this was local to the procedure, but masm doesn't do 
; local arrays correctly.

szTemp	db	18 dup (0)

	.code

PowerOf10	proto

;ten	dq	10.0
ten7	dq	1.0e6
;ten17	dq	1.0e17
;rounder	dq	5.0e10


; Convert a floating point register to ASCII.  For internal use.
; The result always has exactly 18 digits, with zero padding on the
; left if required.
;
; Entry:	ST(0) = a number to convert, 0 <= ST(0) < 1E19.
;		szTemp = an 18-character buffer.
;
; Exit:		szTemp = the converted result.

FloatToBCD	PROC	public uses esi edi

    sub esp, 10

	; The fbstp instruction converts the top of the stack to a
	; packed BCD form in ten bytes, with two digits per byte.  The top 
	; byte has the sign, which we ignore.

 	; fbstp [esp]
 	fbstp REAL10 ptr [esp]

	; Now we need to unpack the BCD to ASCII.

    lea esi, [esp+8]
    lea edi, [szTemp]
    mov ecx, 9

    .REPEAT
	mov al, [esi]          ; .... .... AAAA BBBB
	dec esi
	rol ax, 12             ; BBBB .... .... AAAA
	rol ah, 4              ; .... BBBB .... AAAA
	and ax, 0f0fh          ; 0000 BBBB 0000 AAAA
	add ax, 3030h          ; 3B3A
	mov [edi], ax
	add edi, 2
	dec ecx
    .UNTIL ZERO?

    add esp, 10
    ret

FloatToBCD	ENDP

;
; Convert a double precision number to a string.
;
; Entry:	fpin = 8-byte double to convert
;		szDbl = character buffer
;
; Exit:		szDbl = converted value
;
; szDbl should be at least 19 bytes long.
;		

FloatToStrX	PROC	stdcall public USES esi edi, 
		fpin: QWORD, 
		szDbl: PTR CHAR

    LOCAL	iExp: DWORD
    LOCAL	stat: WORD
    LOCAL	mystat: WORD

; Special case zero.  fxtract fails for zero.
	
    mov edi, [szDbl]

    .if	(dword ptr [fpin] == 0) && (dword ptr [fpin][4] == 0)
      mov byte ptr [edi], '0'
      mov byte ptr [edi][1], 0
      ret
    .endif

; Check for a negative number.

    .if	(sdword ptr [fpin][4] < 0)
      and byte ptr [fpin][7], 07fh	; change to positive
      mov byte ptr [edi], '-'		; store a minus sign
      inc edi
    .endif

; Initialize the floating point unit and load our value onto the stack.

    fclex
    fstcw [stat]
    mov [mystat], 027fh
    fldcw [mystat]

    fld [fpin]
    fld st(0)

; Compute the closest power of 10 below the number.  We can't get an
; exact value because of rounding.  We could get close by adding in
; log10(mantissa), but it still wouldn't be exact.  Since we'll have to
; check the result anyway, it's silly to waste cycles worrying about
; the mantissa.
;
; The exponent is basically log2(fpin).  Those of you who remember
; algebra realize that log2(fpin) x log10(2) = log10(fpin), which is
; what we want.

    fxtract			; ST=> mantissa, exponent, fpin
    fstp st(0)			; drop the mantissa
    fldlg2			; push log10(2)
    fmulp st(1), st		; ST = log10(fpin), fpin
    fistp [iExp]		; ST = fpin

; An 8-byte double can carry almost 16 digits of precision.  Actually, it's
; 15.9 digits, so some numbers close to 1E17 will be wrong in the bottom
; digit.  If this is a concern, change the '16' to a '15'.
;
; A 10-byte double can carry almost 19 digits, but fbstp only stores the
; guaranteed 18.  If you're doing 10-byte doubles, change the '16' to '18'.

    .IF	([iExp] < 16)
      fld st(0)			; ST = fpin, fpin
      frndint			; ST = int(fpin), fpin
      fcomp st(1)		; ST = fpin, status set
      fstsw ax
      .IF (ah & FP_EQUALTO)	; if EQUAL

; We have an integer!  Lucky day.  Go convert it into a temp buffer.

	call FloatToBCD

	mov eax, 17
	mov ecx, [iExp]
	sub eax, ecx
	inc ecx
	lea esi, [szTemp][eax]

; The off-by-one order of magnitude problem below can hit us here.  
; We just trim off the possible leading zero.

	.IF (byte ptr [esi] == '0')
	  inc esi
	  dec ecx
	.ENDIF

; Copy the rest of the converted BCD value to our buffer.

	rep movsb
	jmp ftsExit

      .ENDIF
    .ENDIF

; We use the format [-]d.ddddddE+ddd.  That means we only need a maximum
; of 7 decimal places.  Let's have fbstp do our rounding for us.

    mov eax, 6
    sub eax, [iExp]	; adjust exponent to 7
    call PowerOf10X

; Either we have exactly 7 digits, or we have exactly 6 digits.  We can
; detect that condition and adjust now.

    fcom [ten7]
    ; x0nnnn00 means top of stack > ten7
    ; x0nnnn01 means top of stack < ten7
    ; x1nnnn00 means top of stack = ten7
    fstsw ax
    .IF (ah & 1)
      fmul [ten]
      dec iExp
    .ENDIF

; Go convert to BCD.

    call FloatToBCD

    lea esi, [szTemp+11]	; point to converted buffer

; If the exponent is between -1 and 6, we can express this as a number
; without scientific notation.

    mov ecx, iExp
    .IF (SDWORD PTR ecx >= -1) && (SDWORD PTR ecx <= 6)

; We need to copy ecx+1 digits, then a decimal point (maybe), then 
; the remaining 6-ecx digits.  If exponent is 0, add a leading 0.

      .IF (SDWORD PTR ecx == -1)
	mov byte ptr [edi], '0'
	inc edi
      .ENDIF

      inc ecx
      rep movsb
      mov byte ptr [edi], '.'
      inc edi
      mov ecx, 6
      sub ecx, [iExp]
      rep movsb

; Trim off trailing zeros.

      .WHILE (byte ptr [edi-1] == '0')
	dec edi
      .ENDW

; If we cleared out all the decimal digits, kill the decimal point, too.

      .IF (byte ptr [edi-1] == '.')
	dec edi
      .ENDIF

; That's it.

      jmp ftsExit

    .ENDIF


; Now convert this to a standard, usable format.  If needed, a minus
; sign is already present in the outgoing buffer, and edi already points
; past it.

    movsb				; copy the first digit
    mov byte ptr [edi], '.'		; plop in a decimal point
    inc edi
    movsd				; copy four more digits
    movsw				; copy two more digits

if 0

; The printf %g specified trims off trailing zeros here.  I dislike
; this, so I've disabled it.  Comment out the if 0 and endif if you
; want this.

    .WHILE (byte ptr [edi][-1] == '0')
      dec edi
    .ENDW
endif

; Shove in the exponent.  If you support 10-byte reals, remember to
; allow 4 digits for the exponent.

    mov byte ptr [edi], 'e'	; start the exponent
    mov eax, [iExp]
    .IF (sdword ptr eax < 0)	; plop in the exponent sign
      mov byte ptr [edi][1], '-'
      neg eax
    .ELSE
      mov byte ptr [edi][1], '+'
    .ENDIF

    mov ecx, 10

    xor edx, edx
    div ecx
    add dl, '0'
    mov [edi][4], dl	; shove in the ones exponent digit

    xor edx, edx
    div ecx
    add dl, '0'
    mov [edi][3], dl	; shove in the tens exponent digit

    xor edx, edx
    div ecx
    add dl, '0'
    mov [edi][2], dl	; shove in the hundreds exponent digit

    add edi, 5		; point to terminator

; Clean up and go home.

ftsExit:
    mov byte ptr [edi], 0
    fldcw [stat]		; restore control word
    fwait

    ret
FloatToStrX	ENDP

PowerOf10X	PROC	public

    mov ecx, eax
    .IF	(SDWORD PTR eax < 0)
	neg eax
    .ENDIF

    fld1

    mov dl, al
    and edx, 0fh
    .IF	(!ZERO?)
	lea edx, [edx+edx*4]
	fld ten_1[edx*2][-10]
	fmulp st(1), st
    .ENDIF

    mov dl, al
    shr dl, 4
    and edx, 0fh
    .IF (!ZERO?)
	lea edx, [edx+edx*4]
	fld ten_16[edx*2][-10]
	fmulp st(1), st
    .ENDIF

    mov dl, ah
    and edx, 1fh
    .IF (!ZERO?)
	lea edx, [edx+edx*4]
	fld ten_256[edx*2][-10]
	fmulp st(1), st
    .ENDIF

    .IF (SDWORD PTR ecx < 0)
	fdivp st(1), st
    .ELSE
	fmulp st(1), st
    .ENDIF

    ret

PowerOf10X	ENDP
f2sGL0:

	invoke MessageBox, 0, chr$("Gotcha!"), chr$("Title"), MB_OK
	exit


; dwtoa, Jan 2005:
; 

  ; ---------------------------------------------------------------
  ; This procedure was written by Tim Roberts
  ; Minor fix by Jibz, December 2004
  ; ---------------------------------------------------------------

;    .486
;    .model flat, stdcall  ; 32 bit memory model
;    option casemap :none  ; case sensitive

;    .code

; 
    ; -------------------------------------------------------------
    ; convert DWORD to ascii string
    ; dwValue is value to be converted
    ; lpBuffer is the address of the receiving buffer
    ; EXAMPLE:
    ; invoke dwtoa,edx,ADDR buffer
    ;
    ; Uses: eax, ecx, edx.
    ; -------------------------------------------------------------

align 4

dwtoaX proc dwValue:DWORD, lpBuffer:DWORD

    push ebx
    push esi
    push edi

    mov eax, dwValue
    mov edi, [lpBuffer]

    test eax,eax
    jnz sign

  zero:
    mov word ptr [edi],30h
    jmp dtaexit

  sign:
    jns pos
    mov byte ptr [edi],'-'
    neg eax
    add edi, 1

  pos:
    mov ecx, 3435973837
    mov esi, edi
	; int 3
;	push eax
;	mov eax, 67890
;	.while (eax > 0)
;		mov ebx,eax
;		mul ecx
;		shr edx, 3
;		mov eax,edx
;		lea edx,[edx*4+edx]
;		add edx,edx
;		sub ebx,edx
;		add bl,'0'
;		mov [edi],bl
;		add edi, 1
;	.endw
;	pop eax

	.while (eax > 0)
		mov ebx,eax
		mul ecx
		shr edx, 3
		mov eax,edx
		lea edx,[edx*4+edx]
		add edx,edx
		sub ebx,edx
		add bl,'0'
		mov [edi],bl
		add edi, 1
	.endw

    mov byte ptr [edi], 0       ; terminate the string			1	2	3	4
    ; We now have all the digits, but in reverse order.		1	10	100	1000

    .while esi < edi
      sub edi, 1
      mov al, [esi]
      mov ah, [edi]
      mov [edi], al
      mov [esi], ah
      add esi, 1
    .endw

  dtaexit:

    pop edi
    pop esi
    pop ebx

    ret

dwtoaX endp

; 

end start
OPT_Linker	link
OPT_Icon	Calc
OPT_WAIT	1
OPT_Susy	CONSOLE
OPT_Tmp2Asm	1

		; int 3
		mov edi, offset f2sTmpBuf+8-1
		xor ecx, ecx

@@:		mov al, [edi]	; get 4 bytes=8 numbers
		dec edi

		mov ah, al		; save byte
		and ah, 15		; low nibble
		add ah, 30h		; convert to ASCII number
		mov [esi+ecx+1], ah

		sal eax, 4		; pull in high nibble
		and ah, 15		; high nibble
		jne NoSkip
		test ecx, ecx
		jne NoSkip
		; dec ecx
		nop
NoSkip:	add ah, 30h		; convert to ASCII number
		mov [esi+ecx], ah
		
		; add esi, 2
		inc ecx
		inc ecx
		cmp ecx, 14-2
		jle @B
		xor eax, eax
		mov [esi+ecx], al


http://www.nabble.com/-Bug-target-29337---New:--mfpmath%3D387-doesn%27t-use-fistp-for-double-to-integer-conversion-td6629450.html
for an extra prescision try to use a `long double'.

$ cat fp.cpp
int convert( long double x ) { return (int)x; }
int convert( double x ) { return (int)x; }

convert(long double):
        fldt    8(%rsp)
        fnstcw  -10(%rsp)
        movzwl  -10(%rsp), %eax
        orb     $12, %ah
        movw    %ax, -12(%rsp)
        fldcw   -12(%rsp)
        fistpl  -16(%rsp)
        fldcw   -10(%rsp)
        movl    -16(%rsp), %eax
        ret

convert(double):
	cvttsd2si	%xmm0, %eax
	; cvtss2si	Convert the lower SP FP value of a to a 64-bit signed integer according to the current rounding mode
	; http://cc.in2p3.fr/doc/INTEL/icc/doc/main_cls/mergedProjects/intref_cls/common/intref_sse_conversion.htm
	; The rounding mode used in such cases is determined by the value in the MXCSR register
	; The _mm_cvttpd_epi32, _mm_cvttsd_si32, and _mm_cvttps_epi32 intrinsics use the
	; truncate rounding mode regardless of the mode specified by the MXCSR register
	; http://msdn.microsoft.com/en-us/library/c8c5hx3b.aspx
	; mul for getting exact precision digits?

        ret 


try -O2 -msse2, you get:
_Z8todoubledd:
        subl    $12, %esp
        fldl    24(%esp)
        faddl   16(%esp)
        fstpl   (%esp)
        movsd   (%esp), %xmm0
        addl    $12, %esp
        cvttsd2si       %xmm0, %eax
        ret


Though I think the movsd should not be there but that is a different
issue.

-- Pinski

http://msdn.microsoft.com/en-us/library/t63833dz(VS.71).aspx
crt log10 with sse2	

http://softwarecommunity.intel.com/articles/eng/2076.htm
Precision Considerations
Because of differences in the precision limits of the x87 FP unit and the XMM registers used for SSE/SSE2 computations,
the results will not necessarily match when rounding numbers with a fractional component very close to 1.0 (i.e., 0.999999999...).
Consider the case where the number to be rounded is 5.99999999. Since the x87 stack represents all numbers at 80-bit
extended precision, the _ftol call will process this number directly on the stack without losing any precision, giving a truncated result of 5.
However, if the CVTTSS2SI sequence is used, the number will be saved off the stack to memory as a 32-bit single precision value and
then reloaded into an XMM register. During the memory store, the number will be rounded to 6.0, since 5.99999999 cannot be
represented with only 32 bits of precision. So, the subsequent conversion to integer will give a result of 6.
This scenario also exists when saving to the double data type, although it takes several more "9's" in the fraction to exceed
the limits of 64-bit precision. Because of this issue, the SSE/SSE2 conversions should not be used in a mission-critical application
unless it is fully validated for these outlying cases.

Also note that the SSE/SSE2 instructions cannot be used to convert to either unsigned 32-bit integers or 64-bit integer data types.
The /Qifist switch is still the best option for handling these cases.

http://www.jorgon.freeserve.co.uk/TestbugHelp/FPcontrol.htm
This is a demonstration of using the SSE and SSE2 (streaming SIMD extensions) control instructions STMXCSR
(store the MXCSR control dword), LDMXCSR (load the MXCSR control dword), and using FXSAVE to see if the
processor supports the Denormals are Zeroes ("DAZ") flag.

http://www.purebasic.fr/english/viewtopic.php?t=28301&postdays=0&postorder=asc&highlight=faster+len&start=15&sid=046d8f81ec316613bbd22b35b3d2f206
natLOG(Mantisssa  * 2^exponent) = LOG(Mantisssa) + exponent*LOG(2)


http://www.programmersheaven.com/mb/x86_asm/153071/153071/i-need-help-on-implementing-a-math-function/?S=B20000
Floating point numbers are stored as an exponent base2 and a mantissa. Basically, 1.5*2^30 is stored as 30 and 1.1b.
The first thing you want is the power of 10 you need for the exponent (we're going for scientific notation here, it's easy enough
to adjust it later if the exponent is in a reasonable range.) You can find this with a quick multiply.
You need to know how many powers of ten it takes to get 2, which is quite simply log10(2) (obviously this is a constant
and doesn't need to be recalculated). That will give you the power of ten you need, unfortunately saying a number is
1.5e9.0308998699 isn't really helpful. That is 1.5*2^30 by the way.
So we use some simple algebra 10^(9.0308998699)==10^(9+.0308998699)==10^9*10^.0308998699.
Calculate what 10^.030899699 is and multiply that by the mantissa. Then simply print the mantissa out as a
decimal integer (with a decimal point after the first digit) and add 'e9' to the end and you're done.
If the exponent base 10 isn't too large or small then you can (if you want) shift the decimal point over and
omit the exponent (if the exponent is 0 you should omit it).
